default:
  image: node:19.8.1-alpine
  cache:
    key: "${CI_COMMIT_REF_SLUG}__${CI_JOB_NAME}"
    paths:
      - ${NPM_CACHE_DIR}
  before_script:
    - apk --no-cache add git
    - npm ci --cache ${NPM_CACHE_DIR} --prefer-offline --no-progress --color=false --quiet
  tags:
    - cg
    - docker

stages:
  - test
  - build
  - e2e
  - publish

variables:
  NPM_CACHE_DIR: ${CI_PROJECT_DIR}/.npm-cache

lint commit messages:
  stage: test
  except:
    - main
  variables:
    GIT_DEPTH: ""
  script:
    - npx commitlint --from $(git rev-parse origin/main)

unit tests & linting:
  stage: test
  except:
    - main
  script:
    - npm run lint
    - npm test -- --coverage
  coverage: /All\sfiles.*?\s+(\d+.\d+)/
  artifacts:
    expire_in: 1 month
    paths:
      - coverage

build:
  stage: build
  except:
    - main
  script:
    - npm run build:storybook
    # Manually construct the URL. The CI_JOB_URL causes a redirect and will break the accessibility tests.
    - echo -e -n "https://commonground.gitlab.io/-/core/design-system/-/jobs/${CI_JOB_ID}/artifacts/build" > ci_environment_url.txt
  artifacts:
    paths:
      - build
      - ci_environment_url.txt
  environment:
    name: $CI_COMMIT_REF_NAME
    url: https://commonground.gitlab.io/-/core/design-system/-/jobs/${CI_JOB_ID}/artifacts/build/index.html
    auto_stop_in: 1 week # this does nothing other than cleaning up the reference in Gitlab environments

accessibility tests:
  stage: e2e
  image: cypress/browsers:node18.6.0-chrome105-ff104
  except:
    - main
  before_script:
    - export CYPRESS_BASE_URL="$(cat ci_environment_url.txt)"
  script:
    - cd e2e
    - npm ci --cache ${NPM_CACHE_DIR} --prefer-offline --no-progress --color=false --quiet
    - $(npm bin)/cypress verify
    - $(npm bin)/cypress run --browser chrome
  artifacts:
    when: always
    paths:
      - e2e/cypress/screenshots

pages:
  stage: publish
  only:
    - tags
  script:
    - mv build/ public/
  dependencies:
    - build
  artifacts:
    paths:
      - public

publish to npm:
  stage: publish
  only:
    - main
  script:
    - npx semantic-release
